package com.android.demo;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;

import org.json.JSONArray;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.Bundle;
import android.telephony.TelephonyManager;
import android.telephony.gsm.GsmCellLocation;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.view.View.OnClickListener;

public class DemoActivity extends Activity {
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		/** Ϊť¼ */
		Button btnGetLocation = (Button) findViewById(R.id.button1);
		btnGetLocation.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				onBtnClick();
			}
		});
	}
    
    /** վϢṹ */
    public class SCell{
    	public int MCC;
    	public int MNC;
    	public int LAC;
    	public int CID;
    }
    
    /** γϢṹ */
    public class SItude{
    	public String latitude;
    	public String longitude;
    }
    
	/** ťص */
	private void onBtnClick() {
		/** һȴ״̬Ŀ */
		ProgressDialog mProgressDialog = new ProgressDialog(this);
		mProgressDialog.setMessage("ڻȡ...");
		mProgressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
		mProgressDialog.show();

		try {
			/** ȡվ */
			SCell cell = getCellInfo();

			/** ݻվݻȡγ */
			SItude itude = getItude(cell);

			/** ȡλ */
			String location = getLocation(itude);

			/** ʾ */
			showResult(cell, location);

			/** رնԻ */
			mProgressDialog.dismiss();
		} catch (Exception e) {
			/** رնԻ */
			mProgressDialog.dismiss();
			/** ʾ */
			TextView cellText = (TextView) findViewById(R.id.cellText);
			cellText.setText(e.getMessage());
			Log.e("Error", e.getMessage());
		}
	}
    
	/**
	 * ȡվϢ
	 * 
	 * @throws Exception
	 */
	private SCell getCellInfo() throws Exception {
		SCell cell = new SCell();

		/** APIȡվϢ */
		TelephonyManager mTelNet = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
		GsmCellLocation location = (GsmCellLocation) mTelNet.getCellLocation();
		if (location == null)
			throw new Exception("ȡվϢʧ");

		String operator = mTelNet.getNetworkOperator();
		int mcc = Integer.parseInt(operator.substring(0, 3));
		int mnc = Integer.parseInt(operator.substring(3));
		int cid = location.getCid();
		int lac = location.getLac();

		/** õݷŵṹ */
		cell.MCC = mcc;
		cell.MNC = mnc;
		cell.LAC = lac;
		cell.CID = cid;

		return cell;
	}
    
	/**
	 * ȡγ
	 * 
	 * @throws Exception
	 */
	private SItude getItude(SCell cell) throws Exception {
		SItude itude = new SItude();

		/** AndroidĬϵHttpClient */
		HttpClient client = new DefaultHttpClient();
		/** POST */
		HttpPost post = new HttpPost("http://www.google.com/loc/json");
		try {
			/** POSTJSON */
			JSONObject holder = new JSONObject();
			holder.put("version", "1.1.0");
			holder.put("host", "maps.google.com");
			holder.put("address_language", "zh_CN");
			holder.put("request_address", true);
			holder.put("radio_type", "gsm");
			holder.put("carrier", "HTC");

			JSONObject tower = new JSONObject();
			tower.put("mobile_country_code", cell.MCC);
			tower.put("mobile_network_code", cell.MNC);
			tower.put("cell_id", cell.CID);
			tower.put("location_area_code", cell.LAC);

			JSONArray towerarray = new JSONArray();
			towerarray.put(tower);
			holder.put("cell_towers", towerarray);

			StringEntity query = new StringEntity(holder.toString());
			post.setEntity(query);

			/** POSTݲȡ */
			HttpResponse response = client.execute(post);
			HttpEntity entity = response.getEntity();
			BufferedReader buffReader = new BufferedReader(new InputStreamReader(entity.getContent()));
			StringBuffer strBuff = new StringBuffer();
			String result = null;
			while ((result = buffReader.readLine()) != null) {
				strBuff.append(result);
			}

			/** صJSONݻþγ */
			JSONObject json = new JSONObject(strBuff.toString());
			JSONObject subjosn = new JSONObject(json.getString("location"));

			itude.latitude = subjosn.getString("latitude");
			itude.longitude = subjosn.getString("longitude");
			
			Log.i("Itude", itude.latitude + itude.longitude);
			
		} catch (Exception e) {
			Log.e(e.getMessage(), e.toString());
			throw new Exception("ȡγȳִ:"+e.getMessage());
		} finally{
			post.abort();
			client = null;
		}
		
    	return itude;
    }
    
	/**
	 * ȡλ
	 * 
	 * @throws Exception
	 */
	private String getLocation(SItude itude) throws Exception {
		String resultString = "";

		/** getֱӽӵURL */
		String urlString = String.format("http://maps.google.cn/maps/geo?key=abcdefg&q=%s,%s", itude.latitude, itude.longitude);
		Log.i("URL", urlString);

		/** ½HttpClient */
		HttpClient client = new DefaultHttpClient();
		/** GET */
		HttpGet get = new HttpGet(urlString);
		try {
			/** GET󲢻÷ */
			HttpResponse response = client.execute(get);
			HttpEntity entity = response.getEntity();
			BufferedReader buffReader = new BufferedReader(new InputStreamReader(entity.getContent()));
			StringBuffer strBuff = new StringBuffer();
			String result = null;
			while ((result = buffReader.readLine()) != null) {
				strBuff.append(result);
			}
			resultString = strBuff.toString();

			/** JSONݣַ */
			if (resultString != null && resultString.length() > 0) {
				JSONObject jsonobject = new JSONObject(resultString);
				JSONArray jsonArray = new JSONArray(jsonobject.get("Placemark").toString());
				resultString = "";
				for (int i = 0; i < jsonArray.length(); i++) {
					resultString = jsonArray.getJSONObject(i).getString("address");
				}
			}
		} catch (Exception e) {
			throw new Exception("ȡλóִ:" + e.getMessage());
		} finally {
			get.abort();
			client = null;
		}

		return resultString;
	}
    
	/** ʾ */
	private void showResult(SCell cell, String location) {
		TextView cellText = (TextView) findViewById(R.id.cellText);
		cellText.setText(String.format("վϢmcc:%d, mnc:%d, lac:%d, cid:%d",
				cell.MCC, cell.MNC, cell.LAC, cell.CID));

		TextView locationText = (TextView) findViewById(R.id.lacationText);
		locationText.setText("λã" + location);
	}
}